          ;************************************
          ;   SOFTWARE FOR ET-BOARD  VER 3.5  *
          ;       PROGRAM TEST 74LS374        *
          ;  DIGITAL OUTPUT OF ET-ADIO BOARD  *
          ;************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
P_OUT:    EQU 8FH         ; port output of 74LS374


          ;******************
          ;*  MAIN PROGRAM  *
          ;******************

START:    LD HL,TAB_LED         ; start address of data LED out
          LD B,TAB_END-TAB_LED  ; number of data LED
          LD C,P_OUT            ; number of port 74LA374

LOOP:     OUTI                  ; out data loop (C) <- (HL)
                                ; INC HL and B = B-1
          CALL DELAY
          JR NZ,LOOP            ; if B not zero goto out loop
          JR START

DELAY:    PUSH AF               ; save zero flag
          PUSH HL               ; save Reg.
          LD HL,8000H           ; delay time
DEL1:     DEC HL
          LD A,H
          OR L
          JR NZ,DEL1

          POP HL               ; restore Reg.
          POP AF               ; restore zero flag
          RET


          ;******************************
          ;* TABLE OF DATA LED DISPLAY  *
          ;******************************

TAB_LED:  DFB 00000001B,00000010B,00000100B,00001000B
          DFB 00010000B,00100000B,01000000B,10000000B
          DFB 10000000B,11000000B,11100000B,11110000B
          DFB 11111000B,11111100B,11111110B,11111111B
TAB_END:
          END
