          ;************************************
          ;   SOFTWARE FOR ET-BOARD  VER 4.0  *
          ;       PROGRAM TEST DAC0832        *
          ;  ANALOG  OUTPUT OF ET-ADIO BOARD  *
          ;************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
IC_DAC:   EQU 88H       ; port control DAC0832
HBUF:     EQU 3FB3H     ; buffer (HEX) of HTOD,DTOH
DBUF:     EQU 3FB5H     ; buffer (DEC) of HTOD,DTOH


          ;********************
          ;*   MAIN PROGRAM   *
          ;********************

TDAC:     LD A,30H
          LD (KEYBUF1),A     ; initial start = 0
          LD (KEYBUF2),A     ; initial start = 0
TDAC1:    CALL DSP           ; display LCD
WR1:      CALL SCANK         ; save key in KEYBUF
          LD A,(KEYBUF)
          CP 0DH
          JR Z,ENTER         ; if pressed Enter jump
          CP 30H             ; check 0 - 9 key
          JR C,WR1
          CP 40H
          JR NC,WR1
          LD (KEYBUF1),A     ; save keycode (ASCII)
          LD A,20H           ; ASCII of "SPACE"
          LD (KEYBUF2),A
          CALL DSP           ; display LCD
          LD B,03H           ; digit to shift
WR11:     LD A,11H           ; call "LEFT_LCD"
          RST 10H
          DEC B
          JR NZ,WR11
WR2:      CALL SCANK         ; save key in KEYBUF
          LD A,(KEYBUF)
          CP 0DH
          JR Z,AUTOZERO      ; if pressed Enter jump
          CP 30H             ; check 0 - 9 key
          JR C,WR2
          CP 40H
          JR NC,WR2
          LD (KEYBUF2),A     ; save keycode (ASCII)
          CALL DSP           ; display LCD
          LD B,03H           ; digit to shift
WR21:     LD A,11H           ; call "LEFT_LCD"
          RST 10H
          DEC B
          JR NZ,WR21
          JR TDAC1
AUTOZERO: LD A,30H
          LD (KEYBUF2),A
ENTER:    CALL OUTDAC
          JR TDAC1

          ;XX -> END OF DAC0832 TEST <- XX


          ;****************
          ;* SUB SCANKEY  *
          ;****************

SCANK:    LD A,02H         ; call "SCANK"
          RST 10H
          CP 0FFH
          JR Z,SCANK      ; loop until keypressed
          LD (KEYBUF),A   ; keycode (ASCII)
          RET


          ;*******************
          ;* SUB LCD DISPLAY *
          ;*******************

DSP:      LD HL,DPWORD      ; get word
          LD A,04H          ; display word
          RST 10H
          LD A,19H          ; call "CUR_OFF"
          RST 10H           ; disable cursor
DSP1:     LD A,(KEYBUF1)
          LD D,A
          LD A,0EH          ; call "WRLCD"
          RST 10H           ; write LCD with ASCII
          LD D,"."          ; ASCII of "."
          LD A,0EH          ; display "."
          RST 10H
          LD A,(KEYBUF2)
          LD D,A
          LD A,0EH          ; call "WRLCD"
          RST 10H           ; write LCD with ASCII
          RET

OUTDAC:   CALL DSP
          LD A,(KEYBUF1)
          LD D,A
          LD A,(KEYBUF2)
          LD E,A
          LD A,1CH          ; call "ASC2_HEX"
          RST 10H           ; DE(ASCII) -> A(HEX)
          CP 51H
          JR NC,OVER
          LD (DBUF+0),A
          LD A,21H          ; call "DTOH"
          RST 10H           ; DEC -> HEX
          LD A,(HBUF+0)
          LD C,A
          LD B,00H
          LD HL,OUTTAB      ; start address out
          ADD HL,BC
          LD A,(HL)         ; address out
          LD (OUTBUF),A     ; out value
          OUT (IC_DAC),A
          LD HL,OKWORD      ; get word OK.
          LD A,04H          ; display word
          RST 10H
          LD A,19H          ; call "CUR_OFF"
          RST 10H           ; disable cursor
          CALL DELAY
          JR SOUND
OVER:     LD A,(OUTBUF)     ; out value
          OUT (IC_DAC),A
          LD HL,ERWORD      ; get word error
          LD A,04H          ; display word
          RST 10H
          LD A,19H          ; call "CUR_OFF"
          RST 10H           ; disable cursor
          CALL DELAY
SOUND:    LD BC,8F80H
          LD HL,8080H
          LD A,48H          ; call "SOUND"
          RST 10H
          RET

DELAY:    LD A,2FH         ; call "DSEC"
          LD B,02H         ; delay time
          RST 10H
          RET


          ;****************************
          ;*** VOLTAGE OUTPUT TABLE ***
          ;****************************

OUTTAB:   DFB  000H,005H,00AH,00FH,014H
          DFB  019H,01FH,024H,029H,02EH
          DFB  033H,038H,03DH,042H,047H
          DFB  04DH,052H,057H,05CH,061H
          DFB  066H,06BH,070H,075H,07AH
          DFB  07FH,085H,08AH,08FH,094H
          DFB  099H,09EH,0A3H,0A8H,0AEH
          DFB  0B3H,0B8H,0BDH,0C2H,0C7H
          DFB  0CCH,0D1H,0D6H,0DBH,0E1H
          DFB  0E6H,0EBH,0F0H,0F5H,0FAH
          DFB  0FFH

DPWORD:   DFB  "ENTER VOLT: ",00
OKWORD:   DFB  "   OUT OK NOW   ",00
ERWORD:   DFB  " OVER LIMIT !!  ",00

OUTBUF:   DFS  1   ; data out buffer
KEYBUF:   DFS  1   ; keyboard buffer
KEYBUF1:  DFS  1   ; key digit1 buffer
KEYBUF2:  DFS  1   ; key digit2 buffer
          END

